
include NSISScriptEditor.inc

.code

include Exception.asm
include NSISCompile.asm
include WriteNSISScriptFile.asm
include NSISDlgProc.asm
include CompileDlgProc.asm

include Wizard.asm
include Wiz1.asm
include Wiz2.asm
include Wiz3.asm
include Wiz4.asm
include Wiz5.asm
include Wiz6.asm
include Wiz7.asm
include Wiz8.asm

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
	mov eax,hInst
	mov hInstance,eax
	mov eax,TRUE
	ret
	
DllEntry Endp

GetOptions proc
	mov eax,offset AddinOpt
	ret

GetOptions endp

InstallDll proc uses ebx hWin:DWORD, fOpt:DWORD
	
	mov	ebx,hWin
	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov	lpHStruct,eax
	mov eax,[eax.ADDINHANDLES].hInst
	mov hRAInstance,eax
	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov	lpPStruct,eax
	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov	lpDStruct,eax
	
	; If Option (fOpt) = 0 then exit
	mov eax,fOpt
	mov fOption,eax
	test eax,eax
	je @exit
	
	;Get the Frame window handle
	mov ebx,[lpHStruct]
	mov ebx,(ADDINHANDLES ptr [ebx]).hWnd
	mov hFrame,ebx
	
	; Allocate menu id: New Installer Script
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDNewScr,eax
	; Allocate menu id; Open Installer Script
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDOpenScr,eax
	; Allocate menu id; Compile Installer
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDCompile,eax
	; Allocate menu id; Nullsoft Scriptable Install System
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDnsis,eax
	
	; Allocate menuitems
	invoke AddToMenu
	
	; Messages to hook into
	mov eax,RAM_COMMAND or RAM_CLOSE or RAM_INITMENUPOPUP

@exit:
	; ECX and EDX must be null before we return
	xor ecx, ecx
	xor edx, edx
	ret 

InstallDll Endp

DllProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	_try offset ED_02
; ======================================================================================================================

	mov	eax, uMsg
	.if eax == AIM_COMMAND
		mov eax,wParam
		movzx edx,ax
		shr eax, 16
		.if edx==IDNewScr && eax==BN_CLICKED
			invoke SaveScriptFiles
			.if eax==TRUE
				invoke ShowWizard
				.if Check==3 ;Open with wizard
					invoke CreateFile,addr FileName,GENERIC_WRITE or GENERIC_READ,FILE_SHARE_WRITE or FILE_SHARE_READ,\
	    				0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	    			mov hScript,eax
	    			
	    			invoke WriteToFile
	    			
					invoke CloseHandle,hScript
				.elseif Check==2 ;Open with template
					invoke CopyFile,addr Template,addr FileName,FALSE 
					
				.elseif Check==1 ;Open empty
					invoke CreateFile,addr FileName,GENERIC_WRITE,0,\
	    				0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	    			mov hScript,eax
					invoke CloseHandle,hScript
				.else
					mov eax,FALSE
					jmp return
				.endif
				call lbl_ADD
			.else
				mov eax,FALSE
				jmp return
			.endif
			
		.elseif edx==IDOpenScr && eax==BN_CLICKED
			invoke RtlZeroMemory,addr FileName,sizeof FileName
			mov edx,lpDStruct 
			mov edx,[edx].ADDINDATA.lpProjectPath 
			invoke OpenFiles,0,addr FileName,edx,addr szOFilterString,addr szOpenNSIS
			.if eax==TRUE 
				call lbl_ADD
			.endif

		.elseif edx==IDCompile && eax==BN_CLICKED
			mov edx,lpDStruct
			.if [edx].ADDINDATA.fProject
				;A project is loaded
				.if NSISPath
					mov eax,TRUE
				.else
					invoke GetNSISPath
				.endif
				.if eax==TRUE
					invoke lstrcpy,addr Commandline,addr NSISPath
					invoke lstrcat,addr Commandline,addr szMakensisexe
					mov edx,lpDStruct
					mov edx,[edx].ADDINDATA.lpProjectPath 
					invoke lstrcat,addr Commandline,edx
					invoke CompileProc
				.endif
			.endif
		.elseif edx==IDnsis && eax==BN_CLICKED
			.if !NSISPath
				invoke GetNSISPath
			.endif
			invoke DialogBoxParam,hInstance,IDD_DLG1,hWin,addr NSISDlgProc,0
		.endif
		
	.ELSEIF eax==AIM_INITMENUPOPUP
		mov eax,lpDStruct
		;Enable/disable the menuitem
		mov edx,MF_GRAYED
		.if [eax].ADDINDATA.fProject
			;A project is loaded
			mov edx,MF_ENABLED
		.endif
		mov eax,[lpHStruct]
		invoke EnableMenuItem,[eax].ADDINHANDLES.hMenu,IDCompile,edx

	.ELSEIF eax==AIM_CLOSE
		push ebx
		mov ebx,[lpHStruct]
		mov ebx,[ebx].ADDINHANDLES.hMenu
		invoke DeleteMenu,ebx,IDNewScr,MF_BYCOMMAND
		invoke DeleteMenu,ebx,IDOpenScr,MF_BYCOMMAND
		invoke DeleteMenu,ebx,IDCompile,MF_BYCOMMAND
		invoke DeleteMenu,ebx,IDnsis,MF_BYCOMMAND
		pop ebx

	.endif

	mov eax,FALSE
; ======================================================================================================================
return:
	_finally
	ret
	
lbl_ADD:
	;Set the filename 
	mov edx,lpDStruct 
	mov edx,[edx].ADDINDATA.lpFile 
	invoke lstrcpy,edx,addr FileName 
	;Open the file 
	push TRUE 
	mov eax,lpPStruct 
	call [eax].ADDINPROCS.lpOpenProjectFile 
	;add file to project
	push FALSE  
	push TRUE  
	lea eax,FileName
	push eax
	mov eax,[lpPStruct]
	call (ADDINPROCS ptr [eax]).lpAddProjectFile
	retn
	
DllProc Endp

AddToMenu proc
	LOCAL hMnuProj:dword
	LOCAL hSubProj:dword
	LOCAL mnui:MENUITEMINFO
	
	_try offset ED_03
; ======================================================================================================================
	invoke RtlZeroMemory,addr mnui,sizeof mnui
	mov ebx,[lpHStruct]
	mov ebx,(ADDINHANDLES ptr [ebx]).hMenu
	mov hMenu,ebx

	invoke GetSubMenu,hMenu,4
	mov hMnuProj,eax

	mov mnui.cbSize,sizeof MENUITEMINFO
	mov mnui.fMask,MIIM_ID or MIIM_TYPE
	mov mnui.fType,MFT_STRING
	
	;InsertMenuItem: New Installer Script
	invoke GetSubMenu,hMnuProj,0
	mov hSubProj,eax
	mov eax,IDNewScr
	mov mnui.wID,eax
	mov mnui.dwTypeData,offset szNewScript
	invoke InsertMenuItem,hSubProj,0,FALSE,addr mnui

	;InsertMenuItem; Open Installer Script
	invoke GetSubMenu,hMnuProj,1
	mov hSubProj,eax
	mov eax,IDOpenScr
	mov mnui.wID,eax
	mov mnui.dwTypeData,offset szOpenScript
	invoke InsertMenuItem,hSubProj,0,FALSE,addr mnui
	
	;InsertMenuItem; Compile Installer
	invoke GetSubMenu,hMenu,4
	mov hSubProj,eax
	mov eax,IDCompile
	mov mnui.wID,eax
	mov mnui.dwTypeData,offset szCompile
	invoke InsertMenuItem,hSubProj,0,FALSE,addr mnui
	
	;InsertMenuItem; Nullsoft Scriptable Install System
	invoke GetSubMenu,hMenu,8
	mov hSubProj,eax
	mov eax,IDnsis
	mov mnui.wID,eax
	mov mnui.dwTypeData,offset szGotoNSIS
	invoke InsertMenuItem,hSubProj,0,FALSE,addr mnui
	
; ======================================================================================================================
return:
	_finally
	ret

AddToMenu endp

OpenFiles proc hOwner:dword,pFilename:dword,pInitdir:dword,pFilterstring:dword,pTitle:dword
	LOCAL	ofn:OPENFILENAME

	_try offset ED_04
; ======================================================================================================================

	invoke RtlZeroMemory,addr ofn,sizeof ofn
	mov ofn.lStructSize,sizeof ofn
	mov eax,hOwner
	mov ofn.hwndOwner,eax
	push hRAInstance
	pop ofn.hInstance
	mov eax,pInitdir 
	mov ofn.lpstrInitialDir,eax
	mov eax,pFilterstring
	mov	ofn.lpstrFilter,eax
	mov eax,pFilename
	mov ofn.lpstrFile,eax
	mov ofn.nMaxFile,256
	mov eax,pTitle
	mov	 ofn.lpstrTitle,eax
	mov ofn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or OFN_EXPLORER
	invoke GetOpenFileName,addr ofn
	
; ======================================================================================================================
return:
	_finally
	ret
	
OpenFiles endp

SaveScriptFiles proc
	LOCAL	ofn:OPENFILENAME

	_try offset ED_05
; ======================================================================================================================

	invoke RtlZeroMemory,addr ofn,sizeof ofn
	mov ofn.lStructSize,sizeof ofn
	mov eax,lpHStruct
	mov eax,[eax.ADDINHANDLES].hWnd
	mov ofn.hwndOwner,eax
	mov ofn.lpstrDefExt,offset szExt
	push hRAInstance
	pop ofn.hInstance
	mov edx,lpDStruct 
	mov edx,[edx].ADDINDATA.lpProjectPath 
	mov ofn.lpstrInitialDir,edx
	mov	ofn.lpstrFilter,offset szSFilterString
	mov ofn.lpstrFile,offset FileName
	mov ofn.nMaxFile,sizeof FileName
	mov	 ofn.lpstrTitle,offset szSaveNSIS
	mov ofn.Flags,OFN_PATHMUSTEXIST or OFN_EXPLORER or OFN_OVERWRITEPROMPT
	invoke GetSaveFileName,addr ofn

; ======================================================================================================================
return:
	_finally
	ret
	
SaveScriptFiles endp

GetNSISPath proc
	LOCAL hkSoftware:dword
	LOCAL hkNSIS:dword
	LOCAL cpath:dword
	LOCAL cbuffer:dword
	LOCAL buffer[128]:byte
	LOCAL retval:dword
	
	_try offset ED_06
; ======================================================================================================================

	mov retval,FALSE
	;Search registry for NSIS installation
	invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,addr szSoftware,0,KEY_QUERY_VALUE ,addr hkSoftware
	.if eax==ERROR_SUCCESS
		invoke RegOpenKeyEx,hkSoftware,addr szNSIS,0,KEY_QUERY_VALUE ,addr hkNSIS
		.if eax==ERROR_SUCCESS
			mov eax,sizeof NSISPath
			mov cpath,eax
			mov cbuffer,128
			invoke RegEnumValue,hkNSIS,0,addr buffer,addr cbuffer,0,0,addr NSISPath,addr cpath
			.if eax==ERROR_SUCCESS
				mov retval,TRUE
			.endif
			invoke RegCloseKey,hkNSIS
		.endif
		invoke RegCloseKey,hkSoftware
	.endif
	.if !retval
		;Search inifile
		mov edx,lpDStruct
		invoke GetPrivateProfileString,addr szNSIS,addr szNSIS,NULL,addr NSISPath,sizeof NSISPath,[edx].ADDINDATA.lpIniFile
		.if eax
			mov retval,TRUE 
		.else
			invoke MessageBox,0,addr szNoNSIS,addr szMDIChildTitle,MB_YESNO or MB_ICONQUESTION
			.if eax==IDYES
				;Browse for it
				invoke lstrcpy,addr Commandline,addr szNSISexe
				invoke OpenFiles,0,addr Commandline,0,addr szNSISFilterString,addr szNSISexe
				.if eax
					invoke lstrlen,addr Commandline
					.while byte ptr Commandline[eax-1]!='\' && eax>1
						dec		eax
					.endw
					invoke lstrcpyn,addr NSISPath,addr Commandline,eax
					;Save path to inifile
					mov edx,lpDStruct
					invoke WritePrivateProfileString,addr szNSIS,addr szNSIS,addr NSISPath,[edx].ADDINDATA.lpIniFile
					mov retval,TRUE 
				.endif
			.endif
		.endif
	.endif
	.if retval
		invoke lstrcat,addr NSISPath,addr szBackslash
	.endif
	mov eax,retval

; ======================================================================================================================
return:
	_finally
	ret

GetNSISPath endp

End DllEntry
